DerethForever.Web/Controllers/PatchController.cs
/*****************************************************************************************
Copyright 2018 Dereth Forever

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.
*****************************************************************************************/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Web;
using System.Web.Mvc;
using Lifestoned.Providers;

using Lifestoned.DataModel.Content;
using Lifestoned.DataModel.Shared;

namespace DerethForever.Web.Controllers
{
    public class PatchController : BaseController
    {
        [HttpGet]
        public ActionResult Index()
        {
            return View();
        }

        [HttpGet]
        public ActionResult Patches()
        {
            return JsonGet(ContentProviderHost.PatchContentProvider.GetPatch());
        }

        [HttpGet]
        public ActionResult Content(int patchId)
        {
            return JsonGet(ContentProviderHost.PatchContentProvider.GetPatchContent(patchId));
        }

        [HttpPost]
        public ActionResult Save(Patch patch)
        {
            // can't trust the auth attribute here
            if (!User.Identity.IsAuthenticated || !User.IsInRole("Admin"))
                return UnauthorizedResult(true);

            ContentProviderHost.PatchContentProvider.SavePatch(patch);
            return OkResult();
        }

        [HttpPost]
        public ActionResult SaveContent(PatchContent content)
        {
            // can't trust the auth attribute here
            if (!User.Identity.IsAuthenticated || !User.IsInRole("Admin"))
                return UnauthorizedResult(true);

            ContentProviderHost.PatchContentProvider.SavePatchContent(content);
            return OkResult();
        }

        [HttpPost]
        public ActionResult DeleteContent(PatchContent content)
        {
            // can't trust the auth attribute here
            if (!User.Identity.IsAuthenticated || !User.IsInRole("Admin"))
                return UnauthorizedResult(true);

            ContentProviderHost.PatchContentProvider.DeletePatchContent(content.PatchId, content.ContentType, content.ContentId);
            return OkResult();
        }

        [HttpPost]
        public ActionResult CheckOutContent(PatchContent content)
        {
            // can't trust the auth attribute here
            if (!User.Identity.IsAuthenticated)
                return UnauthorizedResult(true);

            PatchContent pc = ContentProviderHost.PatchContentProvider.GetPatchContent(content.PatchId, content.ContentType, content.ContentId);
            if (pc == null)
                return HttpNotFound("Specified content not found! It may have been deleted.");

            pc.UserAssigned = new Guid(GetUserGuid());
            pc.LastModified = DateTime.Now;

            ContentProviderHost.PatchContentProvider.SavePatchContent(pc);

            return JsonGet(pc.UserAssigned);
        }

        [HttpPost]
        public ActionResult CheckInContent(PatchContent content)
        {
            // can't trust the auth attribute here
            if (!User.Identity.IsAuthenticated)
                return UnauthorizedResult(true);

            PatchContent pc = ContentProviderHost.PatchContentProvider.GetPatchContent(content.PatchId, content.ContentType, content.ContentId);
            if (pc == null)
                return HttpNotFound("Specified content not found! It may have been deleted.");

            pc.UserAssigned = Guid.Empty;
            pc.LastModified = DateTime.Now;

            ContentProviderHost.PatchContentProvider.SavePatchContent(pc);

            return OkResult();
        }
    }
}

DerethForever.Web/Controllers/WeenieController.cs
/*****************************************************************************************
Copyright 2018 Dereth Forever

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.
*****************************************************************************************/
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Web;
using System.Web.Mvc;
using DerethForever.Web.Models.Discord;
using log4net;
using Lifestoned.DataModel.Gdle;
using Newtonsoft.Json;
using RestSharp;
using Lifestoned.DataModel.Shared;
using Lifestoned.DataModel.Account;
using Lifestoned.Providers;

namespace DerethForever.Web.Controllers
{
    public class WeenieController : BaseController
    {
        private const string _Session_IndexModel = "__weenieIndexModel";
        private const string _Session_DownloadModel = "__weenieDownloadModel";

        private static readonly ILog log = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        private IWeenieProvider Provider => ContentProviderHost.GetProvider<IWeenieProvider>(WeenieChange.TypeName);

        private IWeenieSandboxProvider SandboxProvider => SandboxContentProviderHost.GetProvider<IWeenieSandboxProvider>(WeenieChange.TypeName);

        public IndexModel CurrentIndexModel
        {
            get { return (IndexModel)Session[_Session_IndexModel]; }
            set { Session[_Session_IndexModel] = value; }
        }

        public DownloadChangeModel CurrentDownload
        {
            get { return (DownloadChangeModel)Session[_Session_DownloadModel]; }
            set { Session[_Session_DownloadModel] = value; }
        }

        private Weenie GetWeenieForUser(uint id, string userGuid)
        {
            WeenieChange wc = null;
            ViewBag.UserGuid = null;
            string userToken = GetUserToken();

            if (!string.IsNullOrEmpty(userToken))
            {
                if (string.IsNullOrWhiteSpace(userGuid))
                {
                    Guid uid = new Guid(GetUserGuid());
                    // no userGuid specified, assume your own sandbox
                    ////wc = SandboxContentProviderHost.CurrentProvider.GetMySandboxedChange(GetUserToken(), id);
                    wc = SandboxProvider.GetChange(uid, id) as WeenieChange;
                }
                else
                {
                    // validate dev/admin or matches your id
                    if (User.IsInRole("Developer") || GetUserGuid() == userGuid)
                        wc = SandboxProvider.GetChange(new Guid(userGuid), id) as WeenieChange;
                    ////wc = SandboxContentProviderHost.CurrentProvider.GetSandboxedChange(Guid.Parse(userGuid), id);
                    else
                        return null;
                }
            }

            Weenie weenie = null;
            if (wc != null)
            {
                weenie = wc.Entry;
                ViewBag.UserGuid = userGuid;
            }
            else
                weenie = Provider.Get(id);
            ////weenie = SandboxContentProviderHost.CurrentProvider.GetWeenie(GetUserToken(), id);

            return weenie;
        }

        [HttpGet]
        public ActionResult SpellList()
        {
            return View("SpellListPopup");
        }

        [HttpGet]
        public ActionResult Recent()
        {
            IndexModel model = CurrentIndexModel ?? new IndexModel();
            ////model.Results = SandboxContentProviderHost.CurrentProvider.RecentChanges(GetUserToken());

            model.Results = Provider.Search(w => w.LastModified >= DateTime.Now.Date.AddDays(-90), 100).OrderByDescending(w => w.LastModified)
                .Select(w => w.ToSearchResult()).ToList();

            return View(model);
        }

        ////[HttpGet]
        ////public ActionResult AllUpdates()
        ////{
        ////    var allUpdates = SandboxContentProviderHost.CurrentProvider.AllUpdates(GetUserToken());
        ////    var zipFile = new ZipFile();
        ////    foreach (var update in allUpdates)
        ////    {
        ////        // build the CachePwn json for this weenie
        ////        var weenie = SandboxContentProviderHost.CurrentProvider.GetWeenie(GetUserToken(), update.WeenieClassId);
        ////        // var cachePwn = Weenie.ConvertFromWeenie(weenie);
        ////        var settings = new JsonSerializerSettings { NullValueHandling = NullValueHandling.Ignore };
        ////        var contents = JsonConvert.SerializeObject(weenie, Formatting.None, settings);

        ////        // build filename
        ////        var name = weenie.Name;
        ////        var removeChars = new List<string>() { "\t", "\n", "!", "\"" };
        ////        foreach (var removeChar in removeChars)
        ////            name = name.Replace(removeChar, "");

        ////        var filename = $"{update.WeenieClassId} - {name}.json";

        ////        // add json to zip file
        ////        zipFile.AddFile(filename, contents);
        ////    }

        ////    var bytes = zipFile.BuildZip();
        ////    string date = string.Format("{0:yyyy-MM-dd_hh-mm}", DateTime.Now);
        ////    return File(bytes, "application/zip", "GDLE-Latest-Updates-" + date + ".zip");
        ////}

        [HttpGet]
        public ActionResult Detail(uint id, string userGuid)
        {
            Weenie weenie = GetWeenieForUser(id, userGuid);

            if (weenie == null)
                return new HttpNotFoundResult();

            return View(weenie);
        }

        [HttpGet]
        public ActionResult Index()
        {
            IndexModel model = CurrentIndexModel ?? new IndexModel();
            BaseModel current = CurrentBaseModel;
            BaseModel.CopyBaseData(current, model);
            CurrentBaseModel = current;

            return View(model);
        }

        [HttpPost]
        public ActionResult Index(IndexModel model)
        {
            if (!ModelState.IsValid)
                return View(model);

            try
            {
                var criteria = ProcessSearchCriteria(model.Criteria);

                ////string token = GetUserToken();
                if (User.Identity.IsAuthenticated)
                {
                    Guid uid = new Guid(GetUserGuid());
                    model.Results = SandboxProvider.Search(uid, criteria).Select(w => w.ToSearchResult()).ToList();
                }
                else
                {
                    model.Results = Provider.Search(criteria).Select(w => w.ToSearchResult()).ToList();
                }

                ////model.Results = SandboxContentProviderHost.CurrentProvider.WeenieSearch(token, model.Criteria);

                ////if (!string.IsNullOrEmpty(token))
                ////{
                ////    List<WeenieChange> mine = SandboxContentProviderHost.CurrentProvider.GetMyWeenieChanges(GetUserToken());
                ////    model.Results.ForEach(w =>
                ////    {
                ////        if (mine.Any(m => m.Entry.WeenieClassId == w.WeenieClassId))
                ////            w.HasSandboxChange = true;
                ////    });
                ////}

                model.ShowResults = true;
            }
            catch (Exception ex)
            {
                model.Results = null;
                model.ShowResults = false;
                model.ErrorMessages.Add("Error retrieving data from the SandboxContentProviderHost");
                model.Exception = ex;
            }

            return View(model);
        }

        [HttpGet]
        public ActionResult Get(uint id, string userGuid)
        {
            Weenie weenie = GetWeenieForUser(id, userGuid);

            if (weenie == null)
                return new HttpNotFoundResult();

            SortTheThings(weenie);
            return JsonGet(weenie);
        }

        [HttpPut]
        [Authorize]
        public ActionResult Put(Weenie model)
        {
            ModelState.Clear();
            // TODO: Better Validation
            ActionResult result = ValidateWeenie(model);

            if (result != null)
            {
                ModelState.Clear();
                return ErrorResult("Validation Failed");
            }

            model.CleanDeletedAndEmptyProperties();
            model.LastModified = DateTime.Now;
            model.ModifiedBy = GetUserName();

            try
            {
                SandboxProvider.UpdateChange(new Guid(GetUserGuid()), model);
                ////SandboxContentProviderHost.CurrentProvider.UpdateWeenie(GetUserToken(), model);

                IndexModel indexModel = new IndexModel();
                indexModel.SuccessMessages.Add("Weenie " + model.WeenieClassId.ToString() + " successfully saved.");
                CurrentIndexModel = indexModel;

                ////return SandboxAction();
                return OkResult();
            }

DerethForever.Web/Views/Shared/CommentModal.cshtml
<div class="modal fade" id="modal-discussion" tabindex="-1" role="dialog">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title">Add Discussion Comment</h4>
            </div>
            <div class="modal-body">
                <form>
                    <input id="discussionUser" type="hidden" />
                    <input id="discussionItem" type="hidden" />
                    <input id="discussionType" type="hidden" />
                    <textarea id="discussionComment" class="form-control" cols="25" rows="3"></textarea>
                </form>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                <button type="button" class="btn btn-primary">Send message</button>
            </div>
        </div>
    </div>
</div>

<script>
    $(function () {
        $('#modal-discussion')
            .on('shown.bs.modal', function (event) {
                var button = $(event.relatedTarget);
                $('#discussionUser').val(button.data('user'));
                $('#discussionItem').val(button.data('item'));
                $('#discussionType').val(button.data('type'));
            })
            .find('.btn-primary').click(function (event) {
                var comment = $('#discussionComment').val();
                var item = $('#discussionItem').val();
                var user = $('#discussionUser').val();
                var type = $('#discussionType').val();

                $.ajax({
                    type: "POST",
                    url: '@Url.Action("AddDiscussionComment", "Sandbox")', @*'@Url.Action("AddDiscussionComment", "Weenie")',*@
                    data: {
                        source: '@(ViewBag.source)',
                        userGuid: user,
                        itemId: item,
                        type: type,
                        discussionComment: comment
                    },
                    success: function(result) {
                        window.location.reload();
                    },
                    error: function (xhr, status, p3, p4){
                        var err = "Error " + " " + status + " " + p3 + " " + p4;
                        if (xhr.responseText && xhr.responseText[0] == "{")
                            err = JSON.parse(xhr.responseText).Message;
                        console.log(err);
                    }
                });

            });
    });
</script>

DerethForever.Web/Views/Shared/ServerSelector.cshtml
@using DerethForever.Web.Controllers

@using (Html.BeginForm("SelectServer", "Account", FormMethod.Post))
{
    @Html.Hidden("href", Request.RawUrl)
    if (BaseController.CurrentUser != null)
    {
        @Html.DropDownList("selectedServer", BaseController.CurrentUser.ManagedWorldSelectListItems, BaseController.CurrentUser.SelectedManagedWorld ?? "Select a World", new { @class = "form-control", style = "margin-top: 8px;", onchange = "this.form.submit();" })
    }
}

DerethForever.Web/Views/Shared/WeenieFinder.cshtml
WEENIE FINDER

@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal well">
        <h4>Weenie Search</h4>
        <hr />

        @if (!string.IsNullOrWhiteSpace(Model.ErrorMessage))
        {
            <div class="alert alert-danger">
                @Html.DisplayFor(m => m.ErrorMessage)
            </div>
        }

        <div class="form-group">
            <label class="control-label col-md-2" for="Criteria_PartialName">Name</label>
            <div class="col-md-10">
                @Html.TextBoxFor(model => model.Criteria.PartialName, new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Criteria.PartialName, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <label class="control-label col-md-2" for="Criteria_WeenieClassId">Weenie Id</label>
            <div class="col-md-10">
                @Html.TextBoxFor(model => model.Criteria.WeenieClassId, new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Criteria.WeenieClassId, "", new {@class = "text-danger"})
            </div>
        </div>

        <div class="form-group">
            <label class="control-label col-md-2" for="Criteria_ItemType">Item Type</label>
            <div class="col-md-10">
                @Html.TextBoxFor(model => model.Criteria.ItemType, new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Criteria.ItemType, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <label class="control-label col-md-2" for="Criteria_WeenieType">Weenie Type</label>
            <div class="col-md-10">
                @Html.TextBoxFor(model => model.Criteria.WeenieType, new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Criteria.WeenieType, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Search" class="btn btn-primary" />
            </div>
        </div>

    </div>
    <hr/>

    if (Model.ShowResults)
    {
        if (Model.Results != null)
        { 
            <table class="table table-striped table-bordered table-hover table-condensed">
                <thead>
                    <tr>
                        <th>Weenie Id</th>
                        <th>Name</th>
                        <th>Description</th>
                        <th>Item Type</th>
                        <th>Weenie Type</th>
                    </tr>
                </thead>
                <tbody>
                    @if (Model.Results.Count == 0)
                    {
                        <tr><td colspan="8" align="center">No results.</td></tr>
                    }
                    @{
                        foreach (var weenie in Model.Results)
                        {
                            <tr>
                                <td>
                                    @Html.ActionLink("[select]", "Edit", "Weenie",  new { id = weenie.WeenieClassId }, new { })
                                    @weenie.WeenieClassId.ToString()
                                </td>
                                <td>
                                    @weenie.Name
                                </td>
                                <td>
                                    @weenie.Description
                                </td>
                                <td>
                                    @weenie.ItemType
                                </td>
                                <td>
                                    @weenie.WeenieType
                                </td>
                            </tr>
                        }
                    }
                </tbody>
            </table>
        }
        else
        {
            <div class="alert alert-info">
               Your search yielded no results.
            </div>
        }
    }
}

DerethForever.Web/Views/Shared/WeenieList.cshtml
@model IEnumerable<Lifestoned.DataModel.Shared.WeenieSearchResult>

@if (Model != null)
{
<table class="table table-striped table-bordered table-hover table-condensed weenie-table">
    <thead>
        <tr>
            <th style="width: 1rem;">&nbsp;</th>
            <th>Id</th>
            <th style="width: auto;">Name</th>
            <th style="width: 95px;">Item Type</th>
            <th style="width: 95px;">Weenie Type</th>
            <th style="width: 13rem;">Last Modified</th>
            <th style="width: 95px;">Modified By</th>
            <th style="width: 16rem; text-wrap:none;">Actions</th>
        </tr>
    </thead>
    <tbody>
        @if (Model.Count() == 0)
        {
            <tr><td colspan="8" align="center">No results.</td></tr>
        }
        @{
            foreach (var weenie in Model)
            {
                <tr class="@(weenie.IsDone ? "done" : weenie.HasSandboxChange ? "working" : "")">
                    <td><i class="glyphicon @(weenie.IsDone ? "glyphicon-ok" : weenie.HasSandboxChange ? "glyphicon-time" : "glyphicon-remove")"></i></td>
                    <td>@weenie.WeenieClassId.ToString()</td>
                    <td>@weenie.Name</td>
                    <td>@weenie.ItemType_Display</td>
                    <td>@weenie.WeenieType_Display</td>
                    <td>@Html.DisplayFor(w => weenie.LastModified)</td>
                    <td>@weenie.ModifiedBy</td>
                    <td>
                        <div class="btn-group" role="group">
                            <a class="btn btn-sm btn-secondary" href="@Url.Action("Edit", "Weenie", new {id = weenie.WeenieClassId})">
                                <span class="glyphicon glyphicon-edit" title="Edit"></span>
                            </a>
                            <a class="btn btn-sm btn-secondary" href="@Url.Action("Clone", "Weenie", new {id = weenie.WeenieClassId})">
                                <span class="glyphicon glyphicon-copy" title="Clone"></span>
                            </a>

                            @if (User.Identity.IsAuthenticated && User.IsInRole("Admin"))
                            {
                                <a class="btn btn-sm btn-secondary" href="@Url.Action("Delete", "Weenie", new { id = weenie.WeenieClassId })">
                                    <span class="glyphicon glyphicon-remove" title="Delete"></span>
                                </a>
                            }

                            <div class="btn-group dropdown" role="group">
                                <button class="btn btn-sm btn-secondary dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true"><span class="glyphicon glyphicon-download" title="Download"></span>&nbsp;<span class="caret"></span></button>
                                <ul class="dropdown-menu">
                                    <li><a href="@Url.Action("DownloadOriginal", "Weenie", new {id = weenie.WeenieClassId})">Original</a></li>
                                    @if (weenie.HasSandboxChange)
                                    {
                                        <li><a href="@Url.Action("DownloadSandbox", "Weenie", new {id = weenie.WeenieClassId})">Sandbox</a></li>
                                    }
                                </ul>
                            </div>
                        </div>
                    </td>
                </tr>
            }
        }
    </tbody>
</table>
    }
    else
    {
<div class="alert alert-info">
    Your search yielded no results.
</div>
}

DerethForever.Web/Views/Shared/_Favicons.cshtml
<link rel="apple-touch-icon" sizes="180x180" href="~/images/apple-touch-icon.png">
<link rel="icon" type="image/png" sizes="32x32" href="~/images/favicon-32x32.png">
<link rel="icon" type="image/png" sizes="16x16" href="~/images/favicon-16x16.png">
<link rel="manifest" href="~/images/manifest.json">
<link rel="mask-icon" href="~/images/safari-pinned-tab.svg" color="#5bbad5">
<meta name="theme-color" content="#ffffff">

DerethForever.Web/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Lifestoned - @ViewBag.Title</title>
    @RenderSection("metaCard", required: false)

    @Styles.Render("~/Styles/css")
    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/bootstrap")
    @Scripts.Render("~/bundles/modernizr")
    @Scripts.Render("~/bundles/vue")
    @Scripts.Render("~/bundles/site")
    @Html.Partial("_Favicons")

    <script type="text/javascript">
        /* autofocus fix */
        $(function () {
            $('[autofocus]').focus();
        });
    </script>
</head>

@{
    string ctrl = HttpContext.Current.Request.RequestContext.RouteData.Values["controller"].ToString();
}

<body data-spy="scroll" data-target=".navbar">
    <div class="navbar navbar-inverse navbar-fixed-top">
        <div class="container">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                @Html.ActionLink(" ", "Index", "Home", new { area = "" }, new { @class = "navbar-brand" })
            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">
                    <li class="@(@ctrl == "WorldRelease" ? "active" : "")">@Html.ActionLink("Releases", "Index", "WorldRelease")</li>
                    <li class="@(@ctrl == "Content" ? "active" : "")">@Html.ActionLink("Content", "Index", "Patch")</li>
                    <li class="@(@ctrl == "Recipe" ? "active" : "") dropdown">
                        @Html.ActionLink("Recipes", "Index", "Recipe", null, new { @class = "dropdown-toggle" })
                        <ul class="dropdown-menu">
                            <li>@Html.ActionLink("Upload JSON Data", "Upload", "Recipe")</li>
                            <li>@Html.ActionLink("New", "Edit", "Recipe")</li>
                        </ul>
                    </li>
                    <li class="dropdown">
                        @Html.ActionLink("Weenies", "Index", "Weenie", null, new { @class = "dropdown-toggle" })
                        <ul class="dropdown-menu">
                            <li>@Html.ActionLink("Upload JSON Data", "Upload", "Weenie")</li>
                            <li>@Html.ActionLink("Recent Changes", "Recent", "Weenie")</li>
                            <li>@Html.ActionLink("New", "New", "Weenie")</li>
                        </ul>
                    </li>
                    <li class="@(ctrl == "Spawn" ? "active" : "") dropdown">
                        @Html.ActionLink("Spawns", "Index", "Spawn", null, new { @class = "dropdown-toggle" })
                        <ul class="dropdown-menu">
                            <li>@Html.ActionLink("Upload JSON Data", "Upload", "Spawn")</li>
                        </ul>
                    </li>
                    <li>@Html.ActionLink("Spells", "Index", "SpellTable")</li>
                </ul>
                @Html.Partial("_LoginPartial")
            </div>
        </div>
        @*@if (User.Identity.IsAuthenticated)
        {
            <div class="container navbar-right">
                <ul class="nav navbar-nav">
                    <li>@Html.ActionLink("Weenies", "Sandbox", "Weenie")</li>
                    <li>@Html.ActionLink("Spawns", "Sandbox", "Spawn")</li>
                </ul>
            </div>
        }*@
    </div>
    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer>
            <p>
                &copy; @DateTime.Now.Year - Lifestoned &nbsp;&nbsp;&nbsp;&nbsp;
                <a href="https://discord.gg/ArdbxEm" title="Join us on Discord"><img src="~/images/discord.png" height="35dp" /></a>
            </p>
        </footer>
    </div>

    @RenderSection("scripts", required: false)
</body>
</html>